<?php

require_once 'custom/PxRoutines/LogicBuilderPackages/lb5bd07ffb1cdb35_04699854/operators/FlowchartOperator_lb5bd07ffb1cdb35_04699854.php';
require_once 'custom/PxRoutines/LogicBuilderPackages/lb5bd07ffb1cdb35_04699854/ControlFlow_lb5bd07ffb1cdb35_04699854.php';

class ForEachEntityOperator_lb5bd07ffb1cdb35_04699854 extends FlowchartOperator_lb5bd07ffb1cdb35_04699854{

    protected $entities;
    protected $currentEntity;
    protected $loopControlPort;

    public function __construct($params){
        parent::__construct($params);
    }

    public function process($params = array()){
        $flowId = $params['flowId'];
        $flowName = $params['flowName'];

        $tearOff = false;

        foreach($this->entities as $entity){
            $this->currentEntity = $entity;
            $nextLinkParam = self::getNextLink($flowId, $this->getElementId(), $this->loopControlPort);

            if($nextLinkParam['toOperator'] == $this->id)
                $tearOff = true;
            else{
                while(($nextLinkParam = self::getNextElement($flowId, $flowName, $this->id, $nextLinkParam)) != false){
                    if($nextLinkParam['toOperator'] == $this->id){
                        $tearOff = true;
                        break;
                    }
                }
                OperatorStack_lb5bd07ffb1cdb35_04699854::getInstance()->clearForEachOperators($flowId, $this->id);
            }

            if($tearOff)
                break;
        }

    }

    protected function setOutControlPort($params){
        if(!empty($params['outControlPorts'])){
            $this->outControlPort = $params['outControlPorts']['controlFlowCompleted']['id'];
            $this->loopControlPort = $params['outControlPorts']['controlFlowLoopBody']['id'];
        }
    }

    public function setInDataPortById($id, $value){
        if($id == 'entities')
            $this->entities = $value;
    }

    public function getOutDataByPortId($portId){
        if($portId == 'entity'){
            return $this->currentEntity;
        }
        return $this->outDataPorts[$portId]['value'];
    }


public static function getNextLink($flowId, $fromOperatorId, $fromPortId){

        foreach(ControlFlow_lb5bd07ffb1cdb35_04699854::$links[$flowId] as $link){
            if($link['fromOperator'] == $fromOperatorId && $link['fromConnector'] == $fromPortId){
                return $link;
            }
        }
        return false;
    }

    public static function getNextElement($flowId, $flowName, $loopId, $nextLinkParam){
        if(empty($nextLinkParam)){
            return false;
        }

        foreach(ControlFlow_lb5bd07ffb1cdb35_04699854::$operators[$flowId] as $operatorParams){
            $opId = $operatorParams['id'];
            if($opId == $nextLinkParam['toOperator']){
                if(!OperatorStack_lb5bd07ffb1cdb35_04699854::getInstance()->getOperatorOne($flowId, $opId)){
                    OperatorStack_lb5bd07ffb1cdb35_04699854::getInstance()->setForEachOperator($flowId, $loopId, $operatorParams);
                }

                if(OperatorStack_lb5bd07ffb1cdb35_04699854::getInstance()->getOperatorOne($flowId, $opId)){
                    self::setInData($flowId, $flowName, $loopId, $opId);
                    OperatorStack_lb5bd07ffb1cdb35_04699854::getInstance()->getOperatorOne($flowId, $opId)->process(array('flowId' => $flowId, 'flowName' => $flowName));

                    return self::getNextLink(
                        $flowId,
                        OperatorStack_lb5bd07ffb1cdb35_04699854::getInstance()->getOperatorOne($flowId, $opId)->getElementId(),
                        OperatorStack_lb5bd07ffb1cdb35_04699854::getInstance()->getOperatorOne($flowId, $opId)->getOutControlPort());
                }
                return false;
            }
        }
        return false;
    }

    protected static function setInData($flowId, $flowName, $loopId, $operatorId){
        $toOperatorId = OperatorStack_lb5bd07ffb1cdb35_04699854::getInstance()->getOperatorOne($flowId, $operatorId)->getElementId();

        $inputDataPorts = OperatorStack_lb5bd07ffb1cdb35_04699854::getInstance()->getOperatorOne($flowId, $operatorId)->getInDataPorts();

        foreach($inputDataPorts as $inPortKey => $inDataPort){
            $prevLink = self::getPrevLink($flowId, $toOperatorId, $inPortKey);
            if(empty($prevLink)){
                continue;
            }
            if(OperatorStack_lb5bd07ffb1cdb35_04699854::getInstance()->getOperatorOne($flowId, $prevLink['fromOperator'])){
                $value = OperatorStack_lb5bd07ffb1cdb35_04699854::getInstance()->getOperatorOne($flowId, $prevLink['fromOperator'])->getOutDataByPortId($prevLink['fromConnector']);
                OperatorStack_lb5bd07ffb1cdb35_04699854::getInstance()->getOperatorOne($flowId, $operatorId)->setInDataPortById($inPortKey, $value);
            }else{
                self::getPrevElementForDataFlow($flowId, $flowName, $loopId, $prevLink['fromOperator']);
                $value = OperatorStack_lb5bd07ffb1cdb35_04699854::getInstance()->getOperatorOne($flowId, $prevLink['fromOperator'])->getOutDataByPortId($prevLink['fromConnector']);
                OperatorStack_lb5bd07ffb1cdb35_04699854::getInstance()->getOperatorOne($flowId, $operatorId)->setInDataPortById($inPortKey, $value);
            }
        }

    }

    protected static function getPrevLink($flowId, $toOperatorId, $toPortId){
        foreach(ControlFlow_lb5bd07ffb1cdb35_04699854::$links[$flowId] as $link){
            if($link['toOperator'] == $toOperatorId && $link['toConnector'] == $toPortId){
                return $link;
            }
        }
        return array();
    }

    protected static function getPrevElementForDataFlow($flowId, $flowName, $loopId, $elemId){
        foreach(ControlFlow_lb5bd07ffb1cdb35_04699854::$operators[$flowId] as $operatorInfo){
            if($operatorInfo['id'] == $elemId){
                if(!OperatorStack_lb5bd07ffb1cdb35_04699854::getInstance()->getOperatorOne($flowId, $elemId)){
                    OperatorStack_lb5bd07ffb1cdb35_04699854::getInstance()->setForEachOperator($flowId, $loopId, $operatorInfo);
                }

                self::setInData($flowId, $flowName, $loopId, $elemId);
                OperatorStack_lb5bd07ffb1cdb35_04699854::getInstance()->getOperatorOne($flowId, $elemId)->process(array('flowId' => $flowId, 'flowName' => $flowName));
            }
        }
    }
}
