<?php

require_once 'custom/PxRoutines/LogicBuilderPackages/lb5bd07ffb1cdb35_04699854/operators/FlowchartOperator_lb5bd07ffb1cdb35_04699854.php';

class RetrieveRelatedEntitiesOperator_lb5bd07ffb1cdb35_04699854_op68 extends FlowchartOperator_lb5bd07ffb1cdb35_04699854{

    protected $entity;
    protected $linkName;

    protected $relatedEntityName = '';
    protected $relatedEntitiesIds = array();
    protected $relatedEntities = array();

    public function __construct($params){
        parent::__construct($params);
    }

    public function setInDataPortById($id, $value){
        if(!empty($this->inDataPorts[$id])){
            if($id == 'entity')
                $this->entity = $value;
            elseif($id=='linkName')
                $this->linkName = $value;
        }
    }

    public function setInDataPorts($params){
        parent::setInDataPorts($params);
        $this->linkName = $this->inDataPorts['linkName']['value'];
    }

    public function process($params = array()){
        if(empty($this->entity) || empty($this->linkName))
            return;

        if(!($this->entity instanceof SugarBean))
            return;

        $linkName = $this->linkName;
        $this->entity->load_relationship($linkName);
        if(!empty($this->entity->contacts)){
            $this->relatedEntityName = $this->entity->contacts->getRelatedModuleName();
            $this->relatedEntitiesIds = $this->entity->contacts->get();
        }
    }

    public function getOutDataByPortId($portId){
        if($portId == 'entities'){
            return $this->getEntities();
        }else if($portId == 'entitiesNumber'){
            return is_array($this->relatedEntitiesIds) ? count($this->relatedEntitiesIds) : 0;
        }else if($portId == 'singleEntity'){
            return $this->getEntity();
        }

        return null;
    }

    protected function getEntities(){
        if(!empty($this->relatedEntitiesIds) &&  count($this->relatedEntities) != count($this->relatedEntitiesIds)){
            foreach($this->relatedEntitiesIds as $id){
                if(empty($this->relatedEntities[$id]))
                    $this->relatedEntities[$id] = BeanFactory::getBean($this->relatedEntityName, $id, array('strict_retrieve' => true));

            }
        }

        return $this->relatedEntities;
    }

    protected function getEntity(){
        if(!empty($this->relatedEntitiesIds)){
            $randEntityId = $this->relatedEntitiesIds[0];
            if(empty($this->relatedEntities))
                $this->relatedEntities[$randEntityId] = BeanFactory::getBean($this->relatedEntityName, $randEntityId, array('strict_retrieve' => true));


            return $this->relatedEntities[$randEntityId];
        }

        return null;
    }

}
