<?php

require_once 'custom/PxRoutines/LogicBuilderPackages/lb5bd08032c8e649_17725555/operators/FlowchartOperator_lb5bd08032c8e649_17725555.php';
require_once 'custom/PxRoutines/LogicBuilderPackages/lb5bd08032c8e649_17725555/helpers/TypeOperations_lb5bd08032c8e649_17725555.php';

class EqualOperator_lb5bd08032c8e649_17725555 extends FlowchartOperator_lb5bd08032c8e649_17725555{

    protected $operand1;
    protected $operand2;
    protected $result;

    public function __construct($params){
        parent::__construct($params);
    }

    public function setInDataPorts($params){

        if(!empty($params['inDataPorts']['operand1']['value']))
            $this->operand1 = $params['inDataPorts']['operand1']['value'];
        if(!empty($params['inDataPorts']['operand2']['value']))
            $this->operand2 = $params['inDataPorts']['operand2']['value'];

        $this->inDataPorts = array(
            'operand1' => array('id' => 'operand1'),
            'operand2' => array('id' => 'operand2')
        );
    }

    public function setInDataPortById($id, $value){
        if($id == 'operand1'){
            $this->operand1 = $value;
        }elseif($id == 'operand2'){
            $this->operand2 = $value;
        }elseif(!empty($this->inDataPorts[$id])){
            $this->inDataPorts[$id]['value'] = $value;
        }
    }

    public function getOutDataByPortId($portId){
        return $this->result;
    }

    public function process($params = array()){

        switch($this->getType()){
            case 'date':
                $operand1 = TypeOperations_lb5bd08032c8e649_17725555::getDatetime($this->operand1);
                $operand2 = TypeOperations_lb5bd08032c8e649_17725555::getDatetime($this->operand2);
                break;
            case 'number':
                $operand1 = TypeOperations_lb5bd08032c8e649_17725555::getNumber($this->operand1);
                $operand2 = TypeOperations_lb5bd08032c8e649_17725555::getNumber($this->operand2);
                break;
            default:
                $operand1 = $this->operand1;
                $operand2 = $this->operand2;
                break;
        }

        $this->result = $this->conditionProcess($operand1, $operand2);
    }

    protected function conditionProcess($operand1, $operand2){
        return $operand1 == $operand2;
    }

    protected function getType(){
        if(TypeOperations_lb5bd08032c8e649_17725555::isDate($this->operand1) && TypeOperations_lb5bd08032c8e649_17725555::isDate($this->operand2))
            return 'date';
        if(TypeOperations_lb5bd08032c8e649_17725555::isNumeric($this->operand1) && TypeOperations_lb5bd08032c8e649_17725555::isNumeric($this->operand2))
            return 'number';
        elseif(TypeOperations_lb5bd08032c8e649_17725555::isString($this->operand1) && TypeOperations_lb5bd08032c8e649_17725555::isString($this->operand2))
            return 'string';

        return '';
    }
}
