<?php

require_once 'custom/PxRoutines/LogicBuilderPackages/lb5bd080452ec3e9_77319669/operators/FlowchartOperator_lb5bd080452ec3e9_77319669.php';
require_once 'custom/PxRoutines/LogicBuilderPackages/lb5bd080452ec3e9_77319669/dataStorage/CollectionStorage_lb5bd080452ec3e9_77319669.php';

class CreateEmailCollectionFromStringOperator_lb5bd080452ec3e9_77319669 extends FlowchartOperator_lb5bd080452ec3e9_77319669{

    protected $flowId;

    protected $string;
    protected $emailAddresses;
    const EMAIL_PATTERN = "/([a-z0-9_\\.-]+)@([\\da-z\\.-]+)\\.([a-z\\.]{2,6})/i";


    public function __construct($params){
        parent::__construct($params);
    }

    public function setInDataPorts($params){
        $this->string = $params['inDataPorts']['string']['value'];
        parent::setInDataPorts($params);
    }

    public function setInDataPortById($id, $value){
        if($id == 'string')
            $this->string = $value;
    }

    public function process($params = array()){
        $this->flowId = $params['flowId'];
        CollectionStorage_lb5bd080452ec3e9_77319669::createCollection($this->getCollectionId(), $this->getAddressesFromString($this->string));
    }

    protected function getAddressesFromString($inAddresses){
        $resultAddresses = array();
        $addresses = array();
        preg_match_all(self::EMAIL_PATTERN, $inAddresses, $addresses);
        if(!empty($addresses[0])){
            foreach($addresses[0] as $address){
                $resultAddresses[] = $address;
            }
        }
        return $resultAddresses;
    }

    public function getOutDataByPortId($portId){
        return array(
            'collectionId' => $this->getCollectionId(),
            'collectionData' => CollectionStorage_lb5bd080452ec3e9_77319669::getCollection($this->getCollectionId())
        );
    }

    protected function getCollectionId(){
        return $this->flowId . $this->id;
    }

}
