<?php

require_once 'custom/PxRoutines/LogicBuilderPackages/lb5bd0807899bc31_87404244/operators/FlowchartOperator_lb5bd0807899bc31_87404244.php';
require_once 'custom/PxRoutines/LogicBuilderPackages/lb5bd0807899bc31_87404244/helpers/DateTimeConverter_lb5bd0807899bc31_87404244.php';
require_once 'custom/PxRoutines/LogicBuilderPackages/lb5bd0807899bc31_87404244/helpers/DecimalConverter_lb5bd0807899bc31_87404244.php';

class GetEntityFieldsOperator_lb5bd0807899bc31_87404244_op50 extends FlowchartOperator_lb5bd0807899bc31_87404244{

    protected $entityName;
    protected $emptyEntity;

    protected $object;
    protected $attributes = array();

    public function __construct($params){
        parent::__construct($params);
    }

    public function setInDataPorts($params){
        $this->setEntityName($params['inDataPorts']['object']['value']);

        $this->inDataPorts = array();
        foreach($params['inDataPorts'] as $key => $value)
            if($key == 'object')
                $this->inDataPorts[$key]['id'] = $value['id'];
            else
                $this->inDataPorts[$key] = $value;
    }

    protected function setEntityName($moduleName){
        $this->entityName = $moduleName;
    }

    public function setInDataPortById($id, $value){
        if($id == 'object'){
            $this->object = $value;
        }else
            parent::setInDataPortById($id, $value);
    }

    public function process($params = array()){
        $this->initOutDataPortsWithAttr();
    }

    protected function initOutDataPortsWithAttr(){
        $this->checkCurrentAttrValue('id');
        if(!empty($this->object->id)){
            $this->attributes['id'] = $this->convertAttrValue('id', $this->object->id);
        }else
            $this->attributes['id'] = null;
    }

    public function getOutDataByPortId($portId){
        $field = $this->outDataPorts[$portId]['value'];
        return $this->attributes[$field];
    }

    protected function convertAttrValue($fieldName, $fieldValue){
        if($this->object instanceof SugarBean){
            if(!empty($this->object->field_defs[$fieldName])){
                $fieldDef = $this->object->field_defs[$fieldName];
            }
        }else{
            if(empty($this->emptyEntity)){
                $this->emptyEntity = BeanFactory::getBean($this->entityName);
            }

            if(!empty($this->emptyEntity->field_defs[$fieldName])){
                $fieldDef = $this->emptyEntity->field_defs[$fieldName];
            }
        }
        if(empty($fieldDef))
            return $fieldValue;

        switch($fieldDef['type']){
            case 'date':
            case 'datetime':
            case 'datetimecombo':
                require_once 'custom/PxRoutines/LogicBuilderPackages/lb5bd0807899bc31_87404244/helpers/DateTimeConverter_lb5bd0807899bc31_87404244.php';
                $fieldValue = DateTimeConverter_lb5bd0807899bc31_87404244::convertToDisplay($fieldDef, $fieldValue);
                break;
            case 'currency':
            case 'decimal':
            case 'double':
            case 'float':
                require_once 'custom/PxRoutines/LogicBuilderPackages/lb5bd0807899bc31_87404244/helpers/DecimalConverter_lb5bd0807899bc31_87404244.php';
                $fieldValue = DecimalConverter_lb5bd0807899bc31_87404244::convertToDisplay($fieldDef, $fieldValue);
                break;
        }

        return $fieldValue;
    }

    protected function checkCurrentAttrValue($fieldName){
        if($fieldName == 'date_entered' && $this->object instanceof SugarBean &&
            empty($this->object->date_entered) && !empty($this->object->fetched_row['date_entered'])){
            $this->object->date_entered = $this->object->fetched_row['date_entered'];
        }
    }

}
