<?php

require_once 'custom/PxRoutines/LogicBuilderPackages/lb5bd0807899bc31_87404244/operators/FlowchartOperator_lb5bd0807899bc31_87404244.php';
require_once 'custom/PxRoutines/LogicBuilderPackages/lb5bd0807899bc31_87404244/helpers/TypeOperations_lb5bd0807899bc31_87404244.php';

class TrivialTemplateMatchPatternOperator_lb5bd0807899bc31_87404244 extends FlowchartOperator_lb5bd0807899bc31_87404244{

    protected $template;
    protected $pattern;

    public function __construct($params){
        parent::__construct($params);
    }

    public function setInDataPorts($params){
        $this->template = $params['inDataPorts']['template']['value'];
        $this->inDataPorts = array('template' => array('id' => 'template'));
    }

    public function setInDataPortById($id, $value){
        if($id == 'template')
            $this->template = $value;
    }

    public function process($params = array()){

        $specChars = array('?', '*');
        $fakeSpecChars = array('ANY_SYMBOL', 'SOME_SYMBOLS');
        $template = str_replace($specChars, $fakeSpecChars, $this->template);
        $template = preg_quote($template);

        $replaces = array(
            array(
                'key' => 'ANY_SYMBOL',
                'val' => '.{1}'
            ),
            array(
                'key' => 'SOME_SYMBOLS',
                'val' => '.+'
            ),
        );
        foreach($replaces as $replace){
            $template = str_replace($replace['key'], $replace['val'], $template);
        }


        $this->pattern = '/'.$template.'/';
    }

    public function getOutDataByPortId($portId){
        return $this->pattern;
    }

}
