<?php

require_once 'custom/PxRoutines/LogicBuilderPackages/lb5bd0809471ba22_23891700/operators/FlowchartOperator_lb5bd0809471ba22_23891700.php';

class DateDifferenceOperator_lb5bd0809471ba22_23891700 extends FlowchartOperator_lb5bd0809471ba22_23891700{

    protected $dateTo;
    protected $dateFrom;
    protected $resultUnits;

    public $result;

    public function __construct($params){
        parent::__construct($params);
    }

    public function setDateTo($dateTo){
        $this->dateTo = $dateTo;
    }

    public function setDateFrom($dateFrom){
        $this->dateFrom = $dateFrom;
    }

    public function setUnits($resultUnits){
        $this->resultUnits = $resultUnits;
    }

    public function setInDataPorts($params){
        $this->dateTo = $params['inDataPorts']['dateTo']['value'];
        $this->dateFrom = $params['inDataPorts']['dateFrom']['value'];
        $this->resultUnits = $params['inDataPorts']['resultUnits']['value'];

        foreach($params['inDataPorts'] as $portId => $val){
            $this->inDataPorts[$portId] = array(
                'id' => $portId
            );
        }
    }

    public function setInDataPortById($id, $value){
        if($id == 'dateTo'){
            $this->dateTo = $value;
        }elseif($id == 'dateFrom'){
            $this->dateFrom = $value;
        }elseif($id == 'resultUnits'){
            $this->resultUnits = $value;
        }elseif(!empty($this->inDataPorts[$id])){
            $this->inDataPorts[$id]['value'] = $value;
        }
    }

    public function process($params = array()){
        $date1 = $this->getTimeDate($this->dateFrom);
        $date2 = $this->getTimeDate($this->dateTo);
        if(empty($date1) || empty($date2)){
            return;
        }

        $this->result = 0;
        $interval = $date1->diff($date2);

        if($interval){
            if($this->resultUnits == 'year')
                $this->result = $interval->y;
            elseif($this->resultUnits == 'month')
                $this->result = $interval->m + $interval->y*12;
            elseif($this->resultUnits == 'quarter')
                $this->result = intval( ($interval->m + $interval->y*12) / 3 );
            elseif($this->resultUnits == 'day')
                $this->result = $interval->days;
            elseif($this->resultUnits == 'week')
                $this->result = intval( $interval->days/7 );
            elseif($this->resultUnits == 'hour')
                $this->result = $interval->days*24 + $interval->h;
            elseif($this->resultUnits == 'minute')
                $this->result = $interval->days*24*60 + $interval->h*60 + $interval->i;
        }

        $date1->getTimestamp();
        $date2->getTimestamp();
        if($date1 < $date2){
            $this->result = $this->result * -1;
        }

    }

    public function getOutDataByPortId($portId){
        if($portId == 'result')
            return $this->result;
        else
            return $this->outDataPorts[$portId]['value'];
    }

    protected function getTimeDate($date){
        global $timedate, $current_user;
        $sugarDT = $timedate->fromUserType($date, 'datetime', $current_user);
        if(empty($sugarDT))
            $sugarDT = $timedate->fromUserType($date, 'date', $current_user);
        if(empty($sugarDT))
            $sugarDT = $timedate->fromDbType($date, 'datetime');
        if(empty($sugarDT))
            $sugarDT = $timedate->fromDbType($date, 'date');

        return $sugarDT;
    }

}
