<?php

require_once 'custom/PxRoutines/LogicBuilderPackages/lb5bd0809471ba22_23891700/operators/FlowchartOperator_lb5bd0809471ba22_23891700.php';
require_once 'custom/PxRoutines/LogicBuilderPackages/lb5bd0809471ba22_23891700/helpers/DateTimeConverter_lb5bd0809471ba22_23891700.php';
require_once 'custom/PxRoutines/LogicBuilderPackages/lb5bd0809471ba22_23891700/helpers/DecimalConverter_lb5bd0809471ba22_23891700.php';

class GetEntityAttributesOperator_lb5bd0809471ba22_23891700_op178 extends FlowchartOperator_lb5bd0809471ba22_23891700{

    protected $entityName;
    protected $emptyEntity;

    protected $entity;
    protected $attributes = array();

    public function __construct($params){
        parent::__construct($params);
    }

    public function setInDataPorts($params){
        $this->setEntityName($params['inDataPorts']['entity']['value']);

        $this->inDataPorts = array();
        foreach($params['inDataPorts'] as $key => $value)
            if($key == 'entity')
                $this->inDataPorts[$key]['id'] = $value['id'];
            else
                $this->inDataPorts[$key] = $value;
    }

    protected function setEntityName($moduleName){
        $this->entityName = $moduleName; //$beanList[$moduleName];
    }

    public function setInDataPortById($id, $value){
        if($id == 'entity'){
            $this->entity = $value;
        }else
            parent::setInDataPortById($id, $value);
    }

    public function process($params = array()){
        $this->initOutDataPortsWithAttr();
    }

    protected function initOutDataPortsWithAttr(){
        $this->checkCurrentAttrValue('id');
        if(!empty($this->entity->id)){
            $this->attributes['id'] = $this->convertAttrValue('id', $this->entity->id);
        }else{
            $this->attributes['id'] = null;
        }
    }

    public function getOutDataByPortId($portId){
        $field = $this->outDataPorts[$portId]['value'];
        return $this->attributes[$field];
    }

    protected function convertAttrValue($fieldName, $fieldValue){

        if($this->entity instanceof SugarBean){
            if(!empty($this->entity->field_defs[$fieldName])){
                $fieldDef = $this->entity->field_defs[$fieldName];
            }
        }else{
            if(empty($this->emptyEntity)){
                $this->emptyEntity = BeanFactory::getBean($this->entityName);
            }

            if(!empty($this->emptyEntity->field_defs[$fieldName])){
                $fieldDef = $this->emptyEntity->field_defs[$fieldName];
            }
        }

        if(empty($fieldDef))
            return $fieldValue;

        switch($fieldDef['type']){
            case 'date':
            case 'datetime':
            case 'datetimecombo':
                require_once 'custom/PxRoutines/LogicBuilderPackages/lb5bd0809471ba22_23891700/helpers/DateTimeConverter_lb5bd0809471ba22_23891700.php';
                $fieldValue = DateTimeConverter_lb5bd0809471ba22_23891700::convertToDisplay($fieldDef, $fieldValue);
                break;
            case 'currency':
            case 'decimal':
            case 'double':
            case 'float':
                require_once 'custom/PxRoutines/LogicBuilderPackages/lb5bd0809471ba22_23891700/helpers/DecimalConverter_lb5bd0809471ba22_23891700.php';
                $fieldValue = DecimalConverter_lb5bd0809471ba22_23891700::convertToDisplay($fieldDef, $fieldValue);
                break;
        }

        return $fieldValue;
    }

    protected function checkCurrentAttrValue($fieldName){
        if($fieldName == 'date_entered' && $this->entity instanceof SugarBean &&
            empty($this->entity->date_entered) && !empty($this->entity->fetched_row['date_entered'])){
            $this->entity->date_entered = $this->entity->fetched_row['date_entered'];
        }
    }

}
