<?php

require_once 'custom/PxRoutines/LogicBuilderPackages/lb5bd0809f640752_81469867/operators/FlowchartOperator_lb5bd0809f640752_81469867.php';
require_once 'custom/PxRoutines/LogicBuilderPackages/lb5bd0809f640752_81469867/helpers/EntityConverter_lb5bd0809f640752_81469867.php';
require_once 'custom/PxRoutines/LogicBuilderPackages/lb5bd0809f640752_81469867/helpers/DateTimeConverter_lb5bd0809f640752_81469867.php';
require_once 'custom/PxRoutines/LogicBuilderPackages/lb5bd0809f640752_81469867/helpers/DecimalConverter_lb5bd0809f640752_81469867.php';

class GetAttributeDataOperator_lb5bd0809f640752_81469867 extends FlowchartOperator_lb5bd0809f640752_81469867{

    protected $entityName;
    protected $entity;
    protected $attributeName;
    protected $attributeLabel;
    protected $entityValues;


    protected $value;

    protected $realValue;
    protected $displayText;

    public function __construct($params){
        parent::__construct($params);
    }

    public function setInDataPorts($params){
        $this->entityName = $params['inDataPorts']['entity']['value'];;
        $this->attributeName = $params['inDataPorts']['attributeName']['value'];;

        parent::setInDataPorts($params);
    }

    public function setInDataPortById($id, $value){
        if($id == 'entity'){
            $this->entity = $value;
        }elseif($id == 'attributeName'){
            $this->attributeName = $value;
        }
    }

    public function process($params = array()){
        $this->entityValues = EntityConverter_lb5bd0809f640752_81469867::toArray($this->entity);

        $this->value = $this->entityValues[$this->attributeName];


        $value = $this->entityValues[$this->attributeName];
        $defs = $this->getAttributeDefs();

        $this->attributeLabel = $this->getFieldLabel($defs['vname']);

        if(empty($defs) || empty($defs['type'])){
            $this->displayText = $value;
        }

        switch($defs['type']){
            case 'enum':
            case 'multienum':
                $this->displayText = $this->getEnumValues($defs);
                break;
            case 'id':
                $this->displayText = $this->getRelateValuesFromId($defs);
                break;
            case 'relate':
                $this->displayText = $this->getRelateValues($defs);
                break;
            case 'date':
            case 'datetime':
            case 'datetimecombo':
                $this->displayText = $this->getDateTimeValues($defs);
                $this->realValue = $this->getRealDateTimeValues($defs);
                break;
            case 'currency':
            case 'decimal':
            case 'double':
            case 'float':
                $this->displayText = $this->getDecimalValues($defs);
                break;
            default:
                $this->displayText = $value;
        }

        if(empty($this->realValue))
            $this->realValue = $this->value;
    }

    public function getOutDataByPortId($portId){
        if($portId == 'value'){
            return $this->realValue;
        }elseif($portId == 'text'){
            return $this->displayText;
        }elseif($portId == 'label'){
            return $this->attributeLabel;
        }elseif($portId == 'name'){
            return $this->attributeName;
        }
        return '';
    }

    protected function getAttributeDefs(){
        $defs = $this->getEntityDefs();
        return !empty($defs[$this->attributeName]) ? $defs[$this->attributeName] : '';
    }

    protected function getEntityDefs(){
        if(!empty($this->entity) && $this->entity instanceof SugarBean){
            if(!empty($this->entity->field_defs)){
                return $this->entity->field_defs;
            }
        }elseif(!empty($this->entityName)){
            $emptyEntity = BeanFactory::getBean($this->entityName);
            if(!empty($emptyEntity->field_defs)){
                return $emptyEntity->field_defs;
            }
        }
        return array();
    }

    protected function getFieldLabel($label){
        return translate($label, $this->entityName);
    }

    protected function getEnumValues($attributeDefs){
        $value = $this->entityValues[$this->attributeName];

        if(is_array($value)){
            $values = $value;
        }else{
            $values = explode(",", str_replace("^","", $value));
        }

        if(!empty($attributeDefs['function'])){
            $list = array(); //call_user_func($attributeDefs['function']);
        }else{
            global $app_list_strings;
            $list = $app_list_strings[$attributeDefs['options']];
        }

        $result = array();
        foreach($values as $item){
            $result[] = !empty($list[$item]) ? $list[$item] : $item;
        }

        return implode(', ', $result);
    }

    protected function getRelateValuesFromId($attributeDefs){
        $defs = $this->getEntityDefs();

        $relatedFieldDefs = array();
        foreach($defs as $val){
            if(
                !empty($val['type']) && $val['type'] == 'relate' &&
                !empty($val['id_name']) && $val['id_name'] == $this->attributeName){
                $relatedFieldDefs = $val;
                break;
            }
        }

        if(!empty($relatedFieldDefs)){
            $this->attributeLabel = $this->getFieldLabel($relatedFieldDefs['vname']);
            return $this->getRelateValues($relatedFieldDefs);
        }

        return $this->entityValues[$this->attributeName];
    }


    protected function getRelateValues($attributeDefs){

        if(!empty($this->displayText))
            return $this->displayText;

        $value = '';
        if(!empty($attributeDefs['module']) && $attributeDefs['id_name']){
            $relatedModuleName = $attributeDefs['module'];
            $relatedIdFieldName = $attributeDefs['id_name'];
            $relatedId = $this->entityValues[$relatedIdFieldName];

            $relatedEntity = BeanFactory::getBean($relatedModuleName, $relatedId, array('strict_retrieve' => true));
            $relatedEntityValues = EntityConverter_lb5bd0809f640752_81469867::toArray($relatedEntity);
            $rname = !empty($attributeDefs['rname']) ? $attributeDefs['rname'] : 'name';
            $value = !empty($relatedEntityValues[$rname]) ? $relatedEntityValues[$rname] : '';
        }

        return $value;
    }

    protected function getDateTimeValues($attributeDefs){
        $value = $this->entityValues[$this->attributeName];

        require_once 'custom/PxRoutines/LogicBuilderPackages/lb5bd0809f640752_81469867/helpers/DateTimeConverter_lb5bd0809f640752_81469867.php';
        return DateTimeConverter_lb5bd0809f640752_81469867::convertToDisplay($attributeDefs, $value);
    }
    protected function getRealDateTimeValues($attributeDefs){
        $value = $this->entityValues[$this->attributeName];

        require_once 'custom/PxRoutines/LogicBuilderPackages/lb5bd0809f640752_81469867/helpers/DateTimeConverter_lb5bd0809f640752_81469867.php';
        return DateTimeConverter_lb5bd0809f640752_81469867::convertToDb($attributeDefs, $value);
    }

    protected function getDecimalValues($attributeDefs){
        $value = $this->entityValues[$this->attributeName];

        require_once 'custom/PxRoutines/LogicBuilderPackages/lb5bd0809f640752_81469867/helpers/DecimalConverter_lb5bd0809f640752_81469867.php';
        return DecimalConverter_lb5bd0809f640752_81469867::convertToDisplay($attributeDefs, $value);
    }

}
