<?php

require_once 'custom/PxRoutines/LogicBuilderPackages/lb5bd0809f640752_81469867/operators/FlowchartOperator_lb5bd0809f640752_81469867.php';
require_once 'custom/PxRoutines/LogicBuilderPackages/lb5bd0809f640752_81469867/helpers/FlowchartTableConverter_lb5bd0809f640752_81469867.php';

class GetHtmlTextFromTemplateOperator_lb5bd0809f640752_81469867 extends FlowchartOperator_lb5bd0809f640752_81469867{

    protected $template;
    protected $attributes;

    protected $text;

    public function __construct($params){
        parent::__construct($params);
    }


    public function process($params = array()){

        if(!empty($this->template->html_body)){
            if($this->flowchartTemplatesExists() && class_exists('\\Sugarcrm\\Sugarcrm\\custom\\PxRoutines\\LBExtensions\\Templates\\Helpers\\TemplateProcessor') && !empty($this->template)){
                $templateEngine = new \Sugarcrm\Sugarcrm\custom\PxRoutines\LBExtensions\Templates\Helpers\TemplateProcessor($this->template, $this->attributes);
                try{
                    $this->text = $templateEngine->process();
                } catch(Exception $e){
                    $this->text = '';
                }
            } else{
                $htmlBody = str_replace(array('%7B%7B', '%7D%7D'), array('{{', '}}'), $this->template->html_body);
                $search = array();
                $replace = array_values($this->attributes);
                $context = $this->getContext();
                foreach($this->attributes as $key => $contextItem){
                    $search[] = '{{' . $context[$key]['value'] . '}}';
                }
                $this->text = str_replace($search, $replace, $htmlBody);
            }
        }
    }

    protected function flowchartTemplatesExists(){
        $lbTemplatesModuleName = 'PX_FlowchartTemplates';
        $lbTemplatesBean = BeanFactory::getBean($lbTemplatesModuleName);

        return !empty($lbTemplatesBean);
    }

    protected function getContext(){
        $context = array();
        if(!empty($this->template)){
            $context = json_decode(htmlspecialchars_decode($this->template->context), true);
        }
        return $context;
    }

    public function setInDataPorts($params){
        if(!empty($params['inDataPorts']))
            $this->inDataPorts = $params['inDataPorts'];

        if(!empty($params['inDataPorts']['templateName']['value'])){
            $templateId = $params['inDataPorts']['templateName']['value'];
            $this->template = BeanFactory::getBean('PX_FlowchartTemplates', $templateId, array('strict_retrieve' => true));
        }
    }

    public function setInDataPortById($id, $value){
        if($id == 'templateName' && !empty($value))
            $this->template = BeanFactory::getBean('PX_FlowchartTemplates', $value, array('strict_retrieve' => true));

        if(!empty($this->inDataPorts[$id])){
            if($id != 'templateName'){
                if($value instanceof FlowchartTable_lb5bd0809f640752_81469867){
                    $this->attributes[$this->inDataPorts[$id]['value']] = FlowchartTableConverter_lb5bd0809f640752_81469867::toHtml($value);
                }else{
                    $this->attributes[$this->inDataPorts[$id]['value']] = str_replace(array("\r\n", "\r", "\n"), '<br />', $value); // str_replace("\r\n", '<br />', $value);
                }
            }
        }
    }


    public function getOutDataByPortId($portId){
        return $this->text;
    }

}
